unit uCommand;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DBCtrls, Grids, DBGrids, RXDBCtrl, ExtCtrls, Db, DBTables,
  ActnList, ComCtrls, ToolWin;

type
  TfrCommand = class(TForm)
    Panel1: TPanel;
    btOK: TButton;
    btCancel: TButton;
    Command: TGroupBox;
    GroupBoxCustomer: TGroupBox;
    dbluName: TDBLookupComboBox;
    DBText1: TDBText;
    lbNumeroCommand: TLabel;
    Panel2: TPanel;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    dbgCommandLigne: TRxDBGrid;
    ActionList1: TActionList;
    NewLigne: TAction;
    DeleteLigne: TAction;
    EditLigne: TAction;
    DBText2: TDBText;

    procedure FormActivate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure NewLigneExecute(Sender: TObject);
    procedure DeleteLigneExecute(Sender: TObject);
    procedure EditLigneExecute(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  frCommand: TfrCommand;

implementation

uses uDM, CommandLigne;

{$R *.DFM}

procedure TfrCommand.FormActivate(Sender: TObject);
begin
  ActiveControl := dbluName;
end;

procedure TfrCommand.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  if (DM.dsCommand.State in dsEditModes) then
  begin
    if ModalResult = mrOk then
    begin
      DM.tbCommand.Post;
    end
    else
    begin
      if (MessageDlg('Unsaved changes, exit anyway?', mtConfirmation,
        [mbYes, mbCancel], 0) = mrYes) then
      begin
        DM.tbCommand.Cancel;
        CanClose := True
      end
      else
        CanClose := False
    end
  end
  else
    CanClose := True;
end;

procedure TfrCommand.NewLigneExecute(Sender: TObject);
begin
  DM.tbCommandLigne.Insert;

  DM.tbCommandLigneIDlcCommand.AsInteger := DM.tbCommandIDCommand.AsInteger;
  frCommandLigne.ShowModal;
  dbgCommandLigne.Invalidate;
end;

procedure TfrCommand.EditLigneExecute(Sender: TObject);
begin
  frCommandLigne.ShowModal;
  dbgCommandLigne.Invalidate;
end;

procedure TfrCommand.DeleteLigneExecute(Sender: TObject);
begin
  if MessageDlg('Delete the highlighted record ?',
    mtConfirmation, [mbYes, mbNo], 0) = idYes then
    DM.tbCommandLigne.Delete;

  dbgCommandLigne.Invalidate;
end;

end.
